VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "HmacSha1 Demo"
   ClientHeight    =   5880
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   9210
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   9210
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtLog 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5115
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   720
      Width           =   9075
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test"
      Height          =   495
      Left            =   6420
      TabIndex        =   2
      Top             =   60
      Width           =   915
   End
   Begin VB.ComboBox cboCase 
      Height          =   345
      Left            =   1020
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   135
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Test case"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'HMAC-SHA-1 Test vectors from RFC 2202:
'
'     Test Cases for HMAC-MD5 and HMAC-SHA-1

Private Const TEST_KEYS As String = _
        "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b" & "0b0b0b0b|" _
      & "4A656665|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaa|" _
      & "0102030405060708090a0b0c0d0e0f10" & "111213141516171819|" _
      & "0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c" & "0c0c0c0c|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
Private Const TEST_DATA As String = _
        "4869205468657265|" _
      & "7768617420646F2079612077616E7420" & "666F72206E6F7468696E673F|" _
      & "dddddddddddddddddddddddddddddddd" & "dddddddddddddddddddddddddddddddd" _
      & "dddddddddddddddddddddddddddddddd" & "dddd|" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcd|" _
      & "546573742057697468205472756E6361" & "74696F6E|" _
      & "54657374205573696E67204C61726765" & "72205468616E20426C6F636B2D53697A" _
      & "65204B6579202D2048617368204B6579" & "204669727374|" _
      & "54657374205573696E67204C61726765" & "72205468616E20426C6F636B2D53697A" _
      & "65204B657920616E64204C6172676572" & "205468616E204F6E6520426C6F636B2D" _
      & "53697A652044617461"
Private Const TEST_EXPECTED As String = _
        "b617318655057264e28bc0b6fb378c8e" & "f146be00|" _
      & "effcdf6ae5eb2fa2d27416d5f184df9c" & "259a7c79|" _
      & "125d7342b9ac11cd91a39af48aa17b4f" & "63f175d3|" _
      & "4c9007f4026250c6bc8414f9bf50c86c" & "2d7235da|" _
      & "4c1a03424b55e07fe7f27be1d58bb932" & "4a9a5a04|" _
      & "aa4ae5e15272d00e95705637ce8a3b55" & "ed402112|" _
      & "e8e99d0f45237d786d6bbaa7965c7808" & "bbff1a91"

Private strKeys() As String
Private strData() As String
Private strExpected() As String
Private HS1 As HS1

Private Function Fold(ByVal S As String) As String
    With HS1
        S = .Encode(.Decode(S), edfHexAsciiAddr, efCrLf)
    End With
    S = vbTab & Replace$(S, vbNewLine, vbNewLine & vbTab)
    Fold = Left$(S, Len(S) - 1)
End Function

Private Sub cboCase_Click()
    With txtLog
        .Text = ""
        .SelStart = 0
    End With
    cmdTest.SetFocus
End Sub

Private Sub cmdTest_Click()
    Dim intCase As Integer
    Dim bytSig() As Byte
    
    intCase = cboCase.ListIndex
    With txtLog
        .Text = ""
        .SelStart = 0
        .SelText = cboCase.List(intCase) & vbNewLine _
                 & String$(Len(cboCase.List(intCase)), "") & vbNewLine
        .SelText = "Key:" & vbNewLine & Fold(strKeys(intCase))
        .SelText = "Data:" & vbNewLine & Fold(strData(intCase))
        With HS1
            .InitHmac .Decode(strKeys(intCase))
            bytSig = .HmacSha1(.Decode(strData(intCase)))
            txtLog.SelText = "HmacSha1 result:" & vbNewLine _
                           & Fold(.Encode(bytSig))
        End With
        .SelText = "Expected (RFC) result:" & vbNewLine & Fold(strExpected(intCase))
        .SelStart = 0
    End With
End Sub

Private Sub Form_Load()
    strKeys = Split(TEST_KEYS, "|")
    strData = Split(TEST_DATA, "|")
    strExpected = Split(TEST_EXPECTED, "|")
    Set HS1 = New HS1
    Show
    With cboCase
        .AddItem "Case 1"
        .AddItem "Case 2"
        .AddItem "Case 3"
        .AddItem "Case 4"
        .AddItem "Case 5"
        .AddItem "Case 6 - Test Using Larger Than Block-Size Key - Hash Key First"
        .AddItem "Case 7 - Test Using Larger Than Block-Size Key and Larger Than One Block-Size Data"
        .ListIndex = 0
    End With
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        If Width < 9450 Then Width = 9450
        If Height < 3690 Then Height = 3690
        With txtLog
            .Move 0, .Top, ScaleWidth, ScaleHeight - .Top
        End With
    End If
End Sub
